<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:org="urn:iec62325.351:tc57wg16:451-1:acknowledgementdocument:7:0" xmlns="urn:entsoe.eu:wgedi:acknowledgement:acknowledgementdocument:6:0" version="1.0" exclude-result-prefixes="org">
	<xsl:output method="xml"/>
	<xsl:template match="org:Acknowledgement_MarketDocument|Acknowledgement_MarketDocument">
		<AcknowledgementDocument>
			<xsl:call-template name="mRID"/>
			<xsl:call-template name="createdDateTime"/>
			<xsl:call-template name="sender_MarketParticipant.mRID"/>
			<xsl:call-template name="sender_MarketParticipant.marketRole.type"/>
			<xsl:call-template name="receiver_MarketParticipant.mRID"/>
			<xsl:call-template name="receiver_MarketParticipant.marketRole.type"/>
			<xsl:call-template name="received_MarketDocument.mRID"/>
			<xsl:call-template name="received_MarketDocument.revisionNumber"/>
			<xsl:call-template name="received_MarketDocument.type"/>
			<xsl:call-template name="received_MarketDocument.title"/>
			<xsl:call-template name="received_MarketDocument.createdDateTime"/>
			<xsl:call-template name="Rejected_TimeSeries"/>
			<xsl:call-template name="Reason"/>
			<xsl:call-template name="InError_Period"/>
		</AcknowledgementDocument>
	</xsl:template>
	<xsl:template name="Rejected_TimeSeries">
		<xsl:for-each select="org:Rejected_TimeSeries|Rejected_TimeSeries">
			<xsl:element name="TimeSeriesRejection">
				<xsl:call-template name="TSmRID"/>
				<xsl:call-template name="version"/>
				<xsl:call-template name="InError_Period"/>
				<xsl:call-template name="Reason"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="InError_Period">
		<xsl:for-each select="org:InError_Period|InError_Period">
			<xsl:element name="TimeIntervalError">
				<xsl:call-template name="timeInterval"/>
				<xsl:call-template name="Reason"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="Reason">
		<xsl:for-each select="org:Reason|Reason">
			<xsl:element name="Reason">
				<xsl:call-template name="code"/>
				<xsl:call-template name="text"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<!-- Attributes ==================================================================-->
	<xsl:template name="mRID">
		<xsl:choose>
			<xsl:when test="count(org:mRID|mRID/@text()) &gt; 0 ">
				<xsl:element name="DocumentIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:mRID|mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="createdDateTime">
		<xsl:choose>
			<xsl:when test="count(org:createdDateTime|createdDateTime/@text()) &gt; 0 ">
				<xsl:element name="DocumentDateTime">
					<xsl:attribute name="v"><xsl:value-of select="org:createdDateTime|createdDateTime/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="sender_MarketParticipant.mRID">
		<xsl:element name="SenderIdentification">
			<xsl:attribute name="v"><xsl:value-of select="org:sender_MarketParticipant.mRID|sender_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:sender_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
		</xsl:element>
	</xsl:template>
	<xsl:template name="sender_MarketParticipant.marketRole.type">
		<xsl:choose>
			<xsl:when test="count(org:sender_MarketParticipant.marketRole.type|sender_MarketParticipant.marketRole.type/@text()) &gt; 0 ">
				<xsl:element name="SenderRole">
					<xsl:attribute name="v"><xsl:value-of select="org:sender_MarketParticipant.marketRole.type|sender_MarketParticipant.marketRole.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="receiver_MarketParticipant.mRID">
		<xsl:element name="ReceiverIdentification">
			<xsl:attribute name="v"><xsl:value-of select="org:receiver_MarketParticipant.mRID|receiver_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:receiver_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
		</xsl:element>
	</xsl:template>
	<xsl:template name="receiver_MarketParticipant.marketRole.type">
		<xsl:choose>
			<xsl:when test="count(org:receiver_MarketParticipant.marketRole.type|receiver_MarketParticipant.marketRole.type/@text()) &gt; 0 ">
				<xsl:element name="ReceiverRole">
					<xsl:attribute name="v"><xsl:value-of select="org:receiver_MarketParticipant.marketRole.type|receiver_MarketParticipant.marketRole.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="received_MarketDocument.mRID">
		<xsl:choose>
			<xsl:when test="count(org:received_MarketDocument.mRID|received_MarketDocument.mRID/@text()) &gt; 0 ">
				<xsl:element name="ReceivingDocumentIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:received_MarketDocument.mRID|received_MarketDocument.mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="received_MarketDocument.revisionNumber">
		<xsl:choose>
			<xsl:when test="count(org:received_MarketDocument.revisionNumber|received_MarketDocument.revisionNumber/@text()) &gt; 0 ">
				<xsl:element name="ReceivingDocumentVersion">
					<xsl:attribute name="v"><xsl:value-of select="org:received_MarketDocument.revisionNumber|received_MarketDocument.revisionNumber/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="received_MarketDocument.type">
		<xsl:choose>
			<xsl:when test="count(org:received_MarketDocument.type|received_MarketDocument.type/@text()) &gt; 0 ">
				<xsl:element name="ReceivingDocumentType">
					<xsl:attribute name="v"><xsl:value-of select="org:received_MarketDocument.type|received_MarketDocument.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="received_MarketDocument.title">
		<xsl:choose>
			<xsl:when test="count(org:received_MarketDocument.title|received_MarketDocument.title/@text()) &gt; 0 ">
				<xsl:element name="ReceivingPayloadName">
					<xsl:attribute name="v"><xsl:value-of select="org:received_MarketDocument.title|received_MarketDocument.title/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="received_MarketDocument.createdDateTime">
		<xsl:choose>
			<xsl:when test="count(org:received_MarketDocument.createdDateTime|received_MarketDocument.createdDateTime/@text()) &gt; 0 ">
				<xsl:element name="DateTimeReceivingDocument">
					<xsl:attribute name="v"><xsl:value-of select="org:received_MarketDocument.createdDateTime|received_MarketDocument.createdDateTime/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="TSmRID">
		<xsl:choose>
			<xsl:when test="count(org:mRID|mRID/@text()) &gt; 0 ">
				<xsl:element name="SendersTimeSeriesIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:mRID|mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="version">
		<xsl:choose>
			<xsl:when test="count(org:version|version/@text()) &gt; 0 ">
				<xsl:element name="SendersTimeSeriesVersion">
					<xsl:attribute name="v"><xsl:value-of select="org:version|version/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="timeInterval">
		<xsl:choose>
			<xsl:when test="count(org:timeInterval|timeInterval/@text()) &gt; 0 ">
				<xsl:element name="QuantityTimeInterval">
					<xsl:attribute name="v"><xsl:value-of select="concat(substring(translate(translate(org:timeInterval|timeInterval/@text(),'&#x9;', ''),'&#xA;',''),1,17),'/',substring(translate(translate(org:timeInterval|timeInterval/@text(),'&#x9;',''),'&#xA;',''),18,17))"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="code">
		<xsl:choose>
			<xsl:when test="count(org:code|code/@text()) &gt; 0 ">
				<xsl:element name="ReasonCode">
					<xsl:attribute name="v"><xsl:value-of select="org:code|code/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="text">
		<xsl:choose>
			<xsl:when test="count(org:text|text/@text()) &gt; 0 ">
				<xsl:element name="ReasonText">
					<xsl:attribute name="v"><xsl:value-of select="org:text|text/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
