<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:org="urn:iec62325.351:tc57wg16:451-2:confirmationdocument:5:0" xmlns="urn:entsoe.eu:wgedi:ess:confirmationreport:4:1" version="1.0" exclude-result-prefixes="org">
	<xsl:output method="xml"/>
	<xsl:template match="org:Confirmation_MarketDocument|Confirmation_MarketDocument">
		<ConfirmationReport>
			<xsl:call-template name="mRID"/>
			<xsl:call-template name="type"/>
			<xsl:call-template name="createdDateTime"/>
			<xsl:call-template name="sender_MarketParticipant.mRID"/>
			<xsl:call-template name="sender_MarketParticipant.marketRole.type"/>
			<xsl:call-template name="receiver_MarketParticipant.mRID"/>
			<xsl:call-template name="receiver_MarketParticipant.marketRole.type"/>
			<xsl:call-template name="schedule_Period.timeInterval"/>
			<xsl:call-template name="confirmed_MarketDocument.mRID"/>
			<xsl:call-template name="confirmed_MarketDocument.revisionNumber"/>
			<xsl:call-template name="domain.mRID"/>
			<xsl:call-template name="subject_MarketParticipant.mRID"/>
			<xsl:call-template name="subject_MarketParticipant.marketRole.type"/>
			<xsl:call-template name="process.processType"/>
			<xsl:call-template name="Reason"/>
			<xsl:call-template name="Imposed_TimeSeries"/>		
			<xsl:call-template name="Confirmed_TimeSeries"/>
		</ConfirmationReport>
	</xsl:template>
	<!-- Entities Information -->
	<xsl:template name="mRID">
		<xsl:choose>
			<xsl:when test="count(org:mRID|mRID/@text()) &gt; 0 ">
				<xsl:element name="DocumentIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:mRID|mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="type">
		<xsl:choose>
			<xsl:when test="count(org:type|type/@text()) &gt; 0 ">
				<xsl:element name="DocumentType">
					<xsl:attribute name="v"><xsl:value-of select="org:type|type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="createdDateTime">
		<xsl:choose>
			<xsl:when test="count(org:createdDateTime|createdDateTime/@text()) &gt; 0 ">
				<xsl:element name="CreationDateTime">
					<xsl:attribute name="v"><xsl:value-of select="org:createdDateTime|createdDateTime/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="sender_MarketParticipant.mRID">
		<xsl:element name="SenderIdentification">
			<xsl:attribute name="v"><xsl:value-of select="org:sender_MarketParticipant.mRID|sender_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:sender_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
		</xsl:element>
	</xsl:template>
	<xsl:template name="sender_MarketParticipant.marketRole.type">
		<xsl:choose>
			<xsl:when test="count(org:sender_MarketParticipant.marketRole.type|sender_MarketParticipant.marketRole.type/@text()) &gt; 0 ">
				<xsl:element name="SenderRole">
					<xsl:attribute name="v">
					<xsl:value-of select="org:sender_MarketParticipant.marketRole.type|sender_MarketParticipant.marketRole.type/@text()"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="receiver_MarketParticipant.mRID">
		<xsl:element name="ReceiverIdentification">
			<xsl:attribute name="v"><xsl:value-of select="org:receiver_MarketParticipant.mRID|receiver_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:receiver_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
		</xsl:element>
	</xsl:template>
	<xsl:template name="receiver_MarketParticipant.marketRole.type">
		<xsl:choose>
			<xsl:when test="count(org:receiver_MarketParticipant.marketRole.type|receiver_MarketParticipant.marketRole.type/@text()) &gt; 0 ">
				<xsl:element name="ReceiverRole">
					<xsl:attribute name="v">
					<xsl:value-of select="org:receiver_MarketParticipant.marketRole.type|receiver_MarketParticipant.marketRole.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="schedule_Period.timeInterval">
		<xsl:choose>
			<xsl:when test="count(org:schedule_Period.timeInterval|schedule_Period.timeInterval/@text()) &gt; 0 ">
				<xsl:element name="ScheduleTimeInterval">
					<xsl:attribute name="v">
					<xsl:value-of select="concat(substring(translate(translate(org:schedule_Period.timeInterval|schedule_Period.timeInterval/@text(),'&#x9;', ''),'&#xA;',''),1,17),'/',substring(translate(translate(org:schedule_Period.timeInterval|schedule_Period.timeInterval/@text(),'&#x9;',''),'&#xA;',''),18,17))"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="confirmed_MarketDocument.mRID">
		<xsl:choose>
			<xsl:when test="count(org:confirmed_MarketDocument.mRID|confirmed_MarketDocument.mRID/@text()) &gt; 0 ">
				<xsl:element name="ConfirmedDocumentIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:confirmed_MarketDocument.mRID|confirmed_MarketDocument.mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="confirmed_MarketDocument.revisionNumber">
		<xsl:choose>
			<xsl:when test="count(org:confirmed_MarketDocument.revisionNumber|confirmed_MarketDocument.revisionNumber/@text()) &gt; 0 ">
				<xsl:element name="ConfirmedDocumentVersion">
					<xsl:attribute name="v"><xsl:value-of select="org:confirmed_MarketDocument.revisionNumber|confirmed_MarketDocument.revisionNumber/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="domain.mRID">
		<xsl:choose>
			<xsl:when test="count(org:domain.mRID|domain.mRID/@text()) &gt; 0 ">
				<xsl:element name="Domain">
					<xsl:attribute name="v"><xsl:value-of select="org:domain.mRID|domain.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:domain.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="subject_MarketParticipant.mRID">
	<xsl:choose>
	<xsl:when test="count(org:subject_MarketParticipant.mRID|subject_MarketParticipant.mRID/@text()) &gt; 0 ">
		<xsl:element name="SubjectParty">
			<xsl:attribute name="v"><xsl:value-of select="org:subject_MarketParticipant.mRID|subject_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:subject_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
		</xsl:element>
		</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="subject_MarketParticipant.marketRole.type">
		<xsl:choose>
			<xsl:when test="count(org:subject_MarketParticipant.marketRole.type|subject_MarketParticipant.marketRole.type/@text()) &gt; 0 ">
				<xsl:element name="SubjectRole">
					<xsl:attribute name="v">
					<xsl:value-of select="org:subject_MarketParticipant.marketRole.type|subject_MarketParticipant.marketRole.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="process.processType">
		<xsl:choose>
			<xsl:when test="count(org:process.processType|process.processType/@text()) &gt; 0 ">
				<xsl:element name="ProcessType">
					<xsl:attribute name="v"><xsl:value-of select="org:process.processType|process.processType/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- TimeSeries -->
	<xsl:template name="Imposed_TimeSeries">
		<xsl:for-each select="org:Imposed_TimeSeries|Imposed_TimeSeries">
			<xsl:element name="ImposedTimeSeries">
			<xsl:call-template name="ImposedTimeSeriesmRID"/>
			<xsl:call-template name="ImposedTimeSeriesversion"/>
			<xsl:call-template name="TimeSeries"/>
			</xsl:element>
			</xsl:for-each>
			</xsl:template>
	<xsl:template name="Confirmed_TimeSeries">
		<xsl:for-each select="org:Confirmed_TimeSeries|Confirmed_TimeSeries">
			<xsl:element name="TimeSeriesConfirmation">
			<xsl:call-template name="TimeSeriesmRID"/>
			<xsl:call-template name="version"/>
			<xsl:call-template name="TimeSeries"/>
			</xsl:element>
			</xsl:for-each>
			</xsl:template>	
	<xsl:template name="TimeSeries">	
			<xsl:call-template name="businessType"/>
			<xsl:call-template name="product"/>
			<xsl:call-template name="objectAggregation"/>
			<xsl:call-template name="in_Domain.mRID"/>
			<xsl:call-template name="out_Domain.mRID"/>
			<xsl:call-template name="marketEvaluationPoint.mRID"/>
			<xsl:call-template name="in_MarketParticipant.mRID"/>
			<xsl:call-template name="out_MarketParticipant.mRID"/>
			<xsl:call-template name="marketAgreement.type"/>
			<xsl:call-template name="marketAgreement.mRID"/>
			<xsl:call-template name="measure_Unit.name"/>
			<xsl:call-template name="curveType"/>
			<xsl:call-template name="Period"/>
			<xsl:call-template name="Reason"/>
	</xsl:template>
	<!-- Elements -->
		<xsl:template name="ImposedTimeSeriesmRID">
		<xsl:choose>
			<xsl:when test="count(org:mRID|mRID/@text()) &gt; 0 ">
				<xsl:element name="ImposedTimeSeriesIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:mRID|mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
			<xsl:template name="ImposedTimeSeriesversion">
		<xsl:choose>
			<xsl:when test="count(org:version|version/@text()) &gt; 0 ">
				<xsl:element name="ImposedTimeSeriesVersion">
					<xsl:attribute name="v"><xsl:value-of select="org:version|version/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="TimeSeriesmRID">
		<xsl:choose>
			<xsl:when test="count(org:mRID|mRID/@text()) &gt; 0 ">
				<xsl:element name="SendersTimeSeriesIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:mRID|mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="version">
		<xsl:choose>
			<xsl:when test="count(org:version|version/@text()) &gt; 0 ">
				<xsl:element name="SendersTimeSeriesVersion">
					<xsl:attribute name="v"><xsl:value-of select="org:version|version/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="businessType">
		<xsl:choose>
			<xsl:when test="count(org:businessType|businessType/@text()) &gt; 0 ">
				<xsl:element name="BusinessType">
					<xsl:attribute name="v"><xsl:value-of select="org:businessType|businessType/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="product">
		<xsl:choose>
			<xsl:when test="count(org:product|product/@text()) &gt; 0 ">
				<xsl:element name="Product">
					<xsl:attribute name="v"><xsl:value-of select="org:product|product/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="objectAggregation">
		<xsl:choose>
			<xsl:when test="count(org:objectAggregation|objectAggregation/@text()) &gt; 0 ">
				<xsl:element name="ObjectAggregation">
					<xsl:attribute name="v"><xsl:value-of select="org:objectAggregation|objectAggregation/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="in_Domain.mRID">
		<xsl:choose>
			<xsl:when test="count(org:in_Domain.mRID|in_Domain.mRID/@text()) &gt; 0 ">
				<xsl:element name="InArea">
					<xsl:attribute name="v"><xsl:value-of select="org:in_Domain.mRID|in_Domain.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:in_Domain.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="out_Domain.mRID">
		<xsl:choose>
			<xsl:when test="count(org:out_Domain.mRID|out_Domain.mRID/@text()) &gt; 0 ">
				<xsl:element name="OutArea">
					<xsl:attribute name="v"><xsl:value-of select="org:out_Domain.mRID|out_Domain.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:out_Domain.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="marketEvaluationPoint.mRID">
		<xsl:choose>
			<xsl:when test="count(org:marketEvaluationPoint.mRID|marketEvaluationPoint.mRID/@text()) &gt; 0 ">
				<xsl:element name="MeteringPointIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:marketEvaluationPoint.mRID|marketEvaluationPoint.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:marketEvaluationPoint.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="in_MarketParticipant.mRID">
	<xsl:choose>
			<xsl:when test="count(org:in_MarketParticipant.mRID|in_MarketParticipant.mRID/@text()) &gt; 0 ">
			<xsl:element name="InParty">
			<xsl:attribute name="v"><xsl:value-of select="org:in_MarketParticipant.mRID|in_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:in_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
			</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="out_MarketParticipant.mRID">
	<xsl:choose>
			<xsl:when test="count(org:out_MarketParticipant.mRID|out_MarketParticipant.mRID/@text()) &gt; 0 ">
			<xsl:element name="OutParty">
			<xsl:attribute name="v"><xsl:value-of select="org:out_MarketParticipant.mRID|out_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:out_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
			</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="marketAgreement.type">
		<xsl:choose>
			<xsl:when test="count(org:marketAgreement.type|marketAgreement.type/@text()) &gt; 0 ">
				<xsl:element name="CapacityContractType">
					<xsl:attribute name="v"><xsl:value-of select="org:marketAgreement.type|marketAgreement.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="marketAgreement.mRID">
		<xsl:choose>
			<xsl:when test="count(org:marketAgreement.mRID|marketAgreement.mRID/@text()) &gt; 0 ">
				<xsl:element name="CapacityAgreementIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:marketAgreement.mRID|marketAgreement.mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="measure_Unit.name">
		<xsl:choose>
			<xsl:when test="count(org:measure_Unit.name|measure_Unit.name/@text()) &gt; 0 ">
				<xsl:element name="MeasurementUnit">
					<xsl:attribute name="v"><xsl:value-of select="org:measure_Unit.name|measure_Unit.name/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="curveType">
		<xsl:choose>
			<xsl:when test="count(org:curveType|curveType/@text()) &gt; 0 ">
				<xsl:element name="CurveType">
					<xsl:attribute name="v"><xsl:value-of select="org:curveType|currency_Unit.name/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="Period">
		<xsl:for-each select="org:Period|Period">
			<xsl:element name="Period">
			<xsl:call-template name="timeInterval"/>
			<xsl:call-template name="resolution"/>
			<xsl:call-template name="Periodpoint"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="Periodpoint">
		<xsl:for-each select="org:Point|Point">
			<xsl:element name="Interval">
			<xsl:call-template name="position"/>
			<xsl:call-template name="quantity"/>
			<xsl:call-template name="PointReason"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<!-- Elements -->	
	<xsl:template name="timeInterval">
		<xsl:choose>
			<xsl:when test="count(org:timeInterval|timeInterval/@text()) &gt; 0 ">
				<xsl:element name="TimeInterval">
					<xsl:attribute name="v">
					<xsl:value-of select="concat(substring(translate(translate(org:timeInterval|timeInterval/@text(),'&#x9;', ''),'&#xA;',''),1,17),'/',substring(translate(translate(org:timeInterval|timeInterval/@text(),'&#x9;',''),'&#xA;',''),18,17))"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="resolution">
		<xsl:choose>
			<xsl:when test="count(org:resolution|resolution/@text()) &gt; 0 ">
				<xsl:element name="Resolution">
					<xsl:attribute name="v"><xsl:value-of select="org:resolution|resolution/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="position">
		<xsl:choose>
			<xsl:when test="count(org:position|position/@text()) &gt; 0 ">
				<xsl:element name="Pos">
					<xsl:attribute name="v"><xsl:value-of select="org:position|position/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="quantity">
		<xsl:choose>
			<xsl:when test="count(org:quantity|quantity/@text()) &gt; 0 ">
				<xsl:element name="Qty">
					<xsl:attribute name="v"><xsl:value-of select="org:quantity|quantity/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="Reason">
		<xsl:for-each select="org:Reason|Reason">
			<xsl:element name="Reason">
				<xsl:call-template name="code"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="PointReason">
		<xsl:for-each select="org:Reason|Reason">
			<xsl:element name="Reason">
				<xsl:call-template name="code"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="code">
		<xsl:element name="ReasonCode">
			<xsl:attribute name="v"><xsl:value-of select="org:code|code/@text()"/></xsl:attribute>
		</xsl:element>
		<xsl:choose>
			<xsl:when test="count(org:text|text/@text()) &gt; 0 ">
				<xsl:element name="ReasonText">
					<xsl:attribute name="v"><xsl:value-of select="org:text|text/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
