<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:org="urn:iec62325.351:tc57wg16:451-3:allocationresultdocument:7:0" xmlns="urn:entsoe.eu:wgedi:ecan:allocationresultsdocument:6:0" version="1.0" exclude-result-prefixes="org">
	<xsl:output method="xml"/>
	<xsl:template match="org:AllocationResult_MarketDocument|AllocationResult_MarketDocument">
		<AllocationResultDocument>
			<xsl:call-template name="mRID"/>
			<xsl:call-template name="revisionNumber"/>
			<xsl:call-template name="type"/>
			<xsl:call-template name="sender_MarketParticipant.mRID"/>
			<xsl:call-template name="sender_MarketParticipant.marketRole.type"/>
			<xsl:call-template name="receiver_MarketParticipant.mRID"/>
			<xsl:call-template name="receiver_MarketParticipant.marketRole.type"/>
			<xsl:call-template name="createdDateTime"/>
			<xsl:call-template name="period.timeInterval"/>
			<xsl:call-template name="domain.mRID"/>
			<xsl:call-template name="subjectParty_MarketParticipant.mRID"/>
			<xsl:call-template name="subjectParty_MarketParticipant.marketRole.type"/>
			<xsl:call-template name="TimeSeries"/>
			<xsl:call-template name="Reason"/>
		</AllocationResultDocument>
	</xsl:template>
	<!-- Entities Information -->
	<xsl:template name="mRID">
		<xsl:choose>
			<xsl:when test="count(org:mRID|mRID/@text()) &gt; 0 ">
				<xsl:element name="DocumentIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:mRID|mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="revisionNumber">
		<xsl:choose>
			<xsl:when test="count(org:revisionNumber|revisionNumber/@text()) &gt; 0 ">
				<xsl:element name="DocumentVersion">
					<xsl:attribute name="v"><xsl:value-of select="org:revisionNumber|revisionNumber/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="type">
		<xsl:choose>
			<xsl:when test="count(org:type|type/@text()) &gt; 0 ">
				<xsl:element name="DocumentType">
					<xsl:attribute name="v"><xsl:value-of select="org:type|type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="sender_MarketParticipant.mRID">
		<xsl:element name="SenderIdentification">
			<xsl:attribute name="v"><xsl:value-of select="org:sender_MarketParticipant.mRID|sender_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:sender_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
		</xsl:element>
	</xsl:template>
	<xsl:template name="sender_MarketParticipant.marketRole.type">
		<xsl:choose>
			<xsl:when test="count(org:sender_MarketParticipant.marketRole.type|sender_MarketParticipant.marketRole.type/@text()) &gt; 0 ">
				<xsl:element name="SenderRole">
					<xsl:attribute name="v"><xsl:value-of select="org:sender_MarketParticipant.marketRole.type|sender_MarketParticipant.marketRole.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="receiver_MarketParticipant.mRID">
		<xsl:element name="ReceiverIdentification">
			<xsl:attribute name="v"><xsl:value-of select="org:receiver_MarketParticipant.mRID|receiver_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:receiver_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
		</xsl:element>
	</xsl:template>
	<xsl:template name="receiver_MarketParticipant.marketRole.type">
		<xsl:choose>
			<xsl:when test="count(org:receiver_MarketParticipant.marketRole.type|receiver_MarketParticipant.marketRole.type/@text()) &gt; 0 ">
				<xsl:element name="ReceiverRole">
					<xsl:attribute name="v">
					<xsl:value-of select="org:receiver_MarketParticipant.marketRole.type|receiver_MarketParticipant.marketRole.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="createdDateTime">
		<xsl:choose>
			<xsl:when test="count(org:createdDateTime|createdDateTime/@text()) &gt; 0 ">
				<xsl:element name="CreationDateTime">
					<xsl:attribute name="v"><xsl:value-of select="org:createdDateTime|createdDateTime/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="period.timeInterval">
		<xsl:choose>
			<xsl:when test="count(org:period.timeInterval|period.timeInterval/@text()) &gt; 0 ">
				<xsl:element name="BidTimeInterval">
					<xsl:attribute name="v">
					<xsl:value-of select="concat(substring(translate(translate(org:period.timeInterval|period.timeInterval/@text(),'&#x9;', ''),'&#xA;',''),1,17),'/',substring(translate(translate(org:period.timeInterval|period.timeInterval/@text(),'&#x9;',''),'&#xA;',''),18,17))"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="domain.mRID">
		<xsl:choose>
			<xsl:when test="count(org:domain.mRID|domain.mRID/@text()) &gt; 0 ">
				<xsl:element name="Domain">
					<xsl:attribute name="v"><xsl:value-of select="org:domain.mRID|domain.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:domain.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>	<xsl:template name="subjectParty_MarketParticipant.mRID">
		<xsl:element name="SubjectParty">
			<xsl:attribute name="v"><xsl:value-of select="org:subjectParty_MarketParticipant.mRID|subjectParty_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:subjectParty_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
		</xsl:element>
	</xsl:template>
	<xsl:template name="subjectParty_MarketParticipant.marketRole.type">
		<xsl:choose>
			<xsl:when test="count(org:subjectParty_MarketParticipant.marketRole.type|subjectParty_MarketParticipant.marketRole.type/@text()) &gt; 0 ">
				<xsl:element name="SubjectRole">
					<xsl:attribute name="v">
					<xsl:value-of select="org:subjectParty_MarketParticipant.marketRole.type|subjectParty_MarketParticipant.marketRole.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- TimeSeries -->
	<xsl:template name="TimeSeries">
		<xsl:for-each select="org:TimeSeries|TimeSeries">
			<xsl:element name="AllocationTimeSeries">
			<xsl:call-template name="TimeSeriesmRID"/>
			
			<xsl:call-template name="bidDocument_MarketDocument.mRID"/>
			<xsl:call-template name="bidDocument_MarketDocument.revisionNumber"/>
			<xsl:call-template name="bidDocument_MarketDocument.bidTimeSeries.mRID"/>
			<xsl:call-template name="auction.mRID"/>
			
			<xsl:call-template name="businessType"/>
			<xsl:call-template name="in_Domain.mRID"/>
			<xsl:call-template name="out_Domain.mRID"/>
			<xsl:call-template name="marketAgreement.type"/>
			<xsl:call-template name="marketAgreement.mRID"/>
			<xsl:call-template name="quantity_Measure_Unit.name"/>
			<xsl:call-template name="currency_Unit.name"/>
			<xsl:call-template name="price_Measure_Unit.name"/>
			<xsl:call-template name="curveType"/>
			<xsl:call-template name="auction.category"/>
			<xsl:call-template name="Period"/>
			<xsl:call-template name="Reason"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<!-- Elements -->
	<xsl:template name="TimeSeriesmRID">
		<xsl:choose>
			<xsl:when test="count(org:mRID|mRID/@text()) &gt; 0 ">
				<xsl:element name="TimeSeriesIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:mRID|mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="bidDocument_MarketDocument.mRID">
		<xsl:choose>
			<xsl:when test="count(org:bidDocument_MarketDocument.mRID|bidDocument_MarketDocument.mRID/@text()) &gt; 0 ">
				<xsl:element name="BidDocumentIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:bidDocument_MarketDocument.mRID|bidDocument_MarketDocument.mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="bidDocument_MarketDocument.revisionNumber">
		<xsl:choose>
			<xsl:when test="count(org:bidDocument_MarketDocument.revisionNumber|bidDocument_MarketDocument.revisionNumber/@text()) &gt; 0 ">
				<xsl:element name="BidDocumentVersion">
					<xsl:attribute name="v"><xsl:value-of select="org:bidDocument_MarketDocument.revisionNumber|bidDocument_MarketDocument.revisionNumber/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>	
<xsl:template name="bidDocument_MarketDocument.bidTimeSeries.mRID">
		<xsl:choose>
			<xsl:when test="count(org:bidDocument_MarketDocument.bidTimeSeries.mRID|bidDocument_MarketDocument.bidTimeSeries.mRID/@text()) &gt; 0 ">
				<xsl:element name="BidIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:bidDocument_MarketDocument.bidTimeSeries.mRID|bidDocument_MarketDocument.bidTimeSeries.mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>		
<xsl:template name="auction.mRID">
		<xsl:choose>
			<xsl:when test="count(org:auction.mRID|auction.mRID/@text()) &gt; 0 ">
				<xsl:element name="AuctionIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:auction.mRID|auction.mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>		
	<xsl:template name="businessType">
		<xsl:choose>
			<xsl:when test="count(org:businessType|businessType/@text()) &gt; 0 ">
				<xsl:element name="BusinessType">
					<xsl:attribute name="v"><xsl:value-of select="org:businessType|businessType/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="in_Domain.mRID">
		<xsl:choose>
			<xsl:when test="count(org:in_Domain.mRID|in_Domain.mRID/@text()) &gt; 0 ">
				<xsl:element name="InArea">
					<xsl:attribute name="v"><xsl:value-of select="org:in_Domain.mRID|in_Domain.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:in_Domain.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="out_Domain.mRID">
		<xsl:choose>
			<xsl:when test="count(org:out_Domain.mRID|out_Domain.mRID/@text()) &gt; 0 ">
				<xsl:element name="OutArea">
					<xsl:attribute name="v"><xsl:value-of select="org:out_Domain.mRID|out_Domain.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:out_Domain.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="marketAgreement.mRID">
		<xsl:choose>
			<xsl:when test="count(org:marketAgreement.mRID|marketAgreement.mRID/@text()) &gt; 0 ">
				<xsl:element name="ContractIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:marketAgreement.mRID|marketAgreement.mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="marketAgreement.type">
		<xsl:choose>
			<xsl:when test="count(org:marketAgreement.type|marketAgreement.type/@text()) &gt; 0 ">
				<xsl:element name="ContractType">
					<xsl:attribute name="v"><xsl:value-of select="org:marketAgreement.type|marketAgreement.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="quantity_Measure_Unit.name">
		<xsl:choose>
			<xsl:when test="count(org:quantity_Measure_Unit.name|quantity_Measure_Unit.name/@text()) &gt; 0 ">
				<xsl:element name="MeasureUnitQuantity">
					<xsl:attribute name="v"><xsl:value-of select="org:quantity_Measure_Unit.name|quantity_Measure_Unit.name/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="currency_Unit.name">
		<xsl:choose>
			<xsl:when test="count(org:currency_Unit.name|currency_Unit.name/@text()) &gt; 0 ">
				<xsl:element name="Currency">
					<xsl:attribute name="v"><xsl:value-of select="org:currency_Unit.name|currency_Unit.name/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="price_Measure_Unit.name">
		<xsl:choose>
			<xsl:when test="count(org:price_Measure_Unit.name|price_Measure_Unit.name/@text()) &gt; 0 ">
				<xsl:element name="MeasureUnitPrice">
					<xsl:attribute name="v"><xsl:value-of select="org:price_Measure_Unit.name|price_Measure_Unit.name/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="curveType">
		<xsl:choose>
			<xsl:when test="count(org:curveType|curveType/@text()) &gt; 0 ">
				<xsl:element name="CurveType">
					<xsl:attribute name="v"><xsl:value-of select="org:curveType|curveType/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="auction.category">
		<xsl:choose>
			<xsl:when test="count(org:auction.category|auction.category/@text()) &gt; 0 ">
				<xsl:element name="ClassificationCategory">
					<xsl:attribute name="v"><xsl:value-of select="org:auction.category|auction.category/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="Period">
		<xsl:for-each select="org:Period|Period">
			<xsl:element name="Period">
			<xsl:call-template name="timeInterval"/>
			<xsl:call-template name="resolution"/>
			<xsl:call-template name="Periodpoint"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="Periodpoint">
		<xsl:for-each select="org:Point|Point">
			<xsl:element name="Interval">
			<xsl:call-template name="position"/>
			<xsl:call-template name="quantity"/>
			<xsl:call-template name="amount_Price.amount"/>
			<xsl:call-template name="secondaryQuantity"/>
			<xsl:call-template name="bidAmount_Price.amount"/>
			<xsl:call-template name="Reason"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<!-- Elements -->	
	<xsl:template name="timeInterval">
		<xsl:choose>
			<xsl:when test="count(org:timeInterval|timeInterval/@text()) &gt; 0 ">
				<xsl:element name="TimeInterval">
					<xsl:attribute name="v">
					<xsl:value-of select="concat(substring(translate(translate(org:timeInterval|timeInterval/@text(),'&#x9;', ''),'&#xA;',''),1,17),'/',substring(translate(translate(org:timeInterval|timeInterval/@text(),'&#x9;',''),'&#xA;',''),18,17))"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="resolution">
		<xsl:choose>
			<xsl:when test="count(org:resolution|resolution/@text()) &gt; 0 ">
				<xsl:element name="Resolution">
					<xsl:attribute name="v"><xsl:value-of select="org:resolution|resolution/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="position">
		<xsl:choose>
			<xsl:when test="count(org:position|position/@text()) &gt; 0 ">
				<xsl:element name="Pos">
					<xsl:attribute name="v"><xsl:value-of select="org:position|position/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="quantity">
		<xsl:choose>
			<xsl:when test="count(org:quantity|quantity/@text()) &gt; 0 ">
				<xsl:element name="Qty">
					<xsl:attribute name="v"><xsl:value-of select="org:quantity|quantity/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="amount_Price.amount">
		<xsl:choose>
			<xsl:when test="count(org:amount_Price.amount|amount_Price.amount/@text()) &gt; 0 ">
				<xsl:element name="PriceAmount">
					<xsl:attribute name="v"><xsl:value-of select="org:amount_Price.amount|amount_Price.amount/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="secondaryQuantity">
		<xsl:choose>
			<xsl:when test="count(org:secondaryQuantity|secondaryQuantity/@text()) &gt; 0 ">
				<xsl:element name="BidQty">
					<xsl:attribute name="v"><xsl:value-of select="org:secondaryQuantity|secondaryQuantity/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="bidAmount_Price.amount">
		<xsl:choose>
			<xsl:when test="count(org:bidAmount_Price.amount|bidAmount_Price.amount/@text()) &gt; 0 ">
				<xsl:element name="BidPriceAmount">
					<xsl:attribute name="v"><xsl:value-of select="org:bidAmount_Price.amount|bidAmount_Price.amount/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="Reason">
		<xsl:for-each select="org:Reason|Reason">
			<xsl:element name="Reason">
				<xsl:call-template name="code"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="code">
		<xsl:element name="ReasonCode">
			<xsl:attribute name="v"><xsl:value-of select="org:code|code/@text()"/></xsl:attribute>
		</xsl:element>
		<xsl:choose>
			<xsl:when test="count(org:text|text/@text()) &gt; 0 ">
				<xsl:element name="ReasonText">
					<xsl:attribute name="v"><xsl:value-of select="org:text|text/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
