<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:org="urn:iec62325.351:tc57wg16:451-4:energyaccountdocument:3:0" xmlns="urn:entsoe.eu:wgedi:esp:energyaccountreport:1:2" version="1.0" exclude-result-prefixes="org">
	<xsl:output method="xml"/>
	<xsl:template match="org:EnergyAccount_MarketDocument|EnergyAccount_MarketDocument">
		<EnergyAccountReport>
			<xsl:call-template name="mRID"/>
			<xsl:call-template name="revisionNumber"/>
			<xsl:call-template name="type"/>
			<xsl:call-template name="docStatus"/>
			<xsl:call-template name="process.processType"/>
			<xsl:call-template name="process.classificationType"/>
			<xsl:call-template name="sender_MarketParticipant.mRID"/>
			<xsl:call-template name="sender_MarketParticipant.marketRole.type"/>
			<xsl:call-template name="receiver_MarketParticipant.mRID"/>
			<xsl:call-template name="receiver_MarketParticipant.marketRole.type"/>
			<xsl:call-template name="createdDateTime"/>
			<xsl:call-template name="period.timeInterval"/>
			<xsl:call-template name="domain.mRID"/>
			<xsl:call-template name="TimeSeries"/>
		</EnergyAccountReport>
	</xsl:template>
	<!-- Entities Information -->
	<xsl:template name="mRID">
		<xsl:choose>
			<xsl:when test="count(org:mRID|mRID/@text()) &gt; 0 ">
				<xsl:element name="DocumentIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:mRID|mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="revisionNumber">
		<xsl:choose>
			<xsl:when test="count(org:revisionNumber|revisionNumber/@text()) &gt; 0 ">
				<xsl:element name="DocumentVersion">
					<xsl:attribute name="v"><xsl:value-of select="org:revisionNumber|revisionNumber/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="type">
		<xsl:choose>
			<xsl:when test="count(org:type|type/@text()) &gt; 0 ">
				<xsl:element name="DocumentType">
					<xsl:attribute name="v"><xsl:value-of select="org:type|type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="docStatus">
		<xsl:choose>
			<xsl:when test="count(org:docStatus|docStatus/@text()) &gt; 0 ">
				<xsl:element name="DocumentStatus">
					<xsl:attribute name="v"><xsl:value-of select="translate(translate(org:docStatus|docStatus/@text(),'&#x9;', ''),'&#xA;','')"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="process.processType">
		<xsl:choose>
			<xsl:when test="count(org:process.processType|process.processType/@text()) &gt; 0 ">
				<xsl:element name="ProcessType">
					<xsl:attribute name="v"><xsl:value-of select="org:process.processType|process.processType/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="process.classificationType">
		<xsl:choose>
			<xsl:when test="count(org:process.classificationType|process.classificationType/@text()) &gt; 0 ">
				<xsl:element name="ClassificationType">
					<xsl:attribute name="v"><xsl:value-of select="org:process.classificationType|process.classificationType/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="sender_MarketParticipant.mRID">
		<xsl:element name="SenderIdentification">
			<xsl:attribute name="v"><xsl:value-of select="org:sender_MarketParticipant.mRID|sender_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:sender_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
		</xsl:element>
	</xsl:template>
	<xsl:template name="sender_MarketParticipant.marketRole.type">
		<xsl:choose>
			<xsl:when test="count(org:sender_MarketParticipant.marketRole.type|sender_MarketParticipant.marketRole.type/@text()) &gt; 0 ">
				<xsl:element name="SenderRole">
					<xsl:attribute name="v"><xsl:value-of select="org:sender_MarketParticipant.marketRole.type|sender_MarketParticipant.marketRole.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="receiver_MarketParticipant.mRID">
		<xsl:element name="ReceiverIdentification">
			<xsl:attribute name="v"><xsl:value-of select="org:receiver_MarketParticipant.mRID|receiver_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:receiver_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
		</xsl:element>
	</xsl:template>
	<xsl:template name="receiver_MarketParticipant.marketRole.type">
		<xsl:choose>
			<xsl:when test="count(org:receiver_MarketParticipant.marketRole.type|receiver_MarketParticipant.marketRole.type/@text()) &gt; 0 ">
				<xsl:element name="ReceiverRole">
					<xsl:attribute name="v"><xsl:value-of select="org:receiver_MarketParticipant.marketRole.type|receiver_MarketParticipant.marketRole.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="createdDateTime">
		<xsl:choose>
			<xsl:when test="count(org:createdDateTime|createdDateTime/@text()) &gt; 0 ">
				<xsl:element name="DocumentDateTime">
					<xsl:attribute name="v"><xsl:value-of select="org:createdDateTime|createdDateTime/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="period.timeInterval">
		<xsl:choose>
			<xsl:when test="count(org:period.timeInterval|period.timeInterval/@text()) &gt; 0 ">
				<xsl:element name="AccountingPeriod">
					<xsl:attribute name="v"><xsl:value-of select="concat(substring(translate(translate(org:period.timeInterval|period.timeInterval/@text(),'&#x9;', ''),'&#xA;',''),1,17),'/',substring(translate(translate(org:period.timeInterval|period.timeInterval/@text(),'&#x9;',''),'&#xA;',''),18,17))"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="domain.mRID">
		<xsl:choose>
			<xsl:when test="count(org:domain.mRID|domain.mRID/@text()) &gt; 0 ">
				<xsl:element name="Domain">
					<xsl:attribute name="v"><xsl:value-of select="org:domain.mRID|domain.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:domain.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- TimeSeries -->
	<xsl:template name="TimeSeries">
		<xsl:for-each select="org:TimeSeries|TimeSeries">
			<xsl:element name="AccountTimeSeries">
				<xsl:call-template name="TimeSeriesmRID"/>
				<xsl:call-template name="businessType"/>
				<xsl:call-template name="product"/>
				<xsl:call-template name="objectAggregation"/>
				<xsl:call-template name="area_Domain.mRID"/>
				<xsl:call-template name="marketParticipant.mRID"/>
				<xsl:call-template name="marketAgreement.mRID"/>
				<xsl:call-template name="measure_Unit.name"/>
				<xsl:call-template name="currency_Unit.name"/>
				<xsl:call-template name="marketEvaluationPoint.mRID"/>
				<xsl:call-template name="Period"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<!-- Elements -->
	<xsl:template name="TimeSeriesmRID">
		<xsl:choose>
			<xsl:when test="count(org:mRID|mRID/@text()) &gt; 0 ">
				<xsl:element name="SendersTimeSeriesIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:mRID|mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="businessType">
		<xsl:choose>
			<xsl:when test="count(org:businessType|businessType/@text()) &gt; 0 ">
				<xsl:element name="BusinessType">
					<xsl:attribute name="v"><xsl:value-of select="org:businessType|businessType/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="product">
		<xsl:choose>
			<xsl:when test="count(org:product|product/@text()) &gt; 0 ">
				<xsl:element name="Product">
					<xsl:attribute name="v"><xsl:value-of select="org:product|product/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="objectAggregation">
		<xsl:choose>
			<xsl:when test="count(org:objectAggregation|objectAggregation/@text()) &gt; 0 ">
				<xsl:element name="ObjectAggregation">
					<xsl:attribute name="v"><xsl:value-of select="org:objectAggregation|objectAggregation/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="area_Domain.mRID">
		<xsl:choose>
			<xsl:when test="count(org:area_Domain.mRID|area_Domain.mRID/@text()) &gt; 0 ">
				<xsl:element name="Area">
					<xsl:attribute name="v"><xsl:value-of select="org:area_Domain.mRID|area_Domain.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:area_Domain.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="marketParticipant.mRID">
		<xsl:choose>
			<xsl:when test="count(org:marketParticipant.mRID|marketParticipant.mRID/@text()) &gt; 0 ">
				<xsl:element name="Party">
					<xsl:attribute name="v"><xsl:value-of select="org:marketParticipant.mRID|marketParticipant.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:marketParticipant.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="marketAgreement.mRID">
		<xsl:choose>
			<xsl:when test="count(org:marketAgreement.mRID|marketAgreement.mRID/@text()) &gt; 0 ">
				<xsl:element name="AgreementIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:marketAgreement.mRID|marketAgreement.mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="measure_Unit.name">
		<xsl:choose>
			<xsl:when test="count(org:measure_Unit.name|measure_Unit.name/@text()) &gt; 0 ">
				<xsl:element name="MeasurementUnit">
					<xsl:attribute name="v"><xsl:value-of select="org:measure_Unit.name|measure_Unit.name/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="currency_Unit.name">
		<xsl:choose>
			<xsl:when test="count(org:currency_Unit.name|currency_Unit.name/@text()) &gt; 0 ">
				<xsl:element name="Currency">
					<xsl:attribute name="v"><xsl:value-of select="org:currency_Unit.name|currency_Unit.name/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="marketEvaluationPoint.mRID">
		<xsl:choose>
			<xsl:when test="count(org:marketEvaluationPoint.mRID|marketEvaluationPoint.mRID/@text()) &gt; 0 ">
				<xsl:element name="AccountingPoint">
					<xsl:attribute name="v"><xsl:value-of select="org:marketEvaluationPoint.mRID|marketEvaluationPoint.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:marketEvaluationPoint.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="Period">
		<xsl:for-each select="org:Period|Period">
			<xsl:element name="Period">
				<xsl:call-template name="timeInterval"/>
				<xsl:call-template name="resolution"/>
				<xsl:call-template name="Periodpoint"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="Periodpoint">
		<xsl:for-each select="org:Point|Point">
			<xsl:element name="AccountInterval">
				<xsl:call-template name="position"/>
				<xsl:call-template name="quantity"/>
				<xsl:call-template name="secondaryQuantity"/>
				<xsl:call-template name="price.amount"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<!-- Elements -->
	<xsl:template name="timeInterval">
		<xsl:choose>
			<xsl:when test="count(org:timeInterval|timeInterval/@text()) &gt; 0 ">
				<xsl:element name="TimeInterval">
					<xsl:attribute name="v"><xsl:value-of select="concat(substring(translate(translate(org:timeInterval|timeInterval/@text(),'&#x9;', ''),'&#xA;',''),1,17),'/',substring(translate(translate(org:timeInterval|timeInterval/@text(),'&#x9;',''),'&#xA;',''),18,17))"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="resolution">
		<xsl:choose>
			<xsl:when test="count(org:resolution|resolution/@text()) &gt; 0 ">
				<xsl:element name="Resolution">
					<xsl:attribute name="v"><xsl:value-of select="org:resolution|resolution/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="position">
		<xsl:choose>
			<xsl:when test="count(org:position|position/@text()) &gt; 0 ">
				<xsl:element name="Pos">
					<xsl:attribute name="v"><xsl:value-of select="org:position|position/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="quantity">
		<xsl:choose>
			<xsl:when test="count(org:quantity|quantity/@text()) &gt; 0 ">
				<xsl:element name="InQty">
					<xsl:attribute name="v"><xsl:value-of select="org:quantity|quantity/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="secondaryQuantity">
		<xsl:choose>
			<xsl:when test="count(org:secondaryQuantity|secondaryQuantity/@text()) &gt; 0 ">
				<xsl:element name="OutQty">
					<xsl:attribute name="v"><xsl:value-of select="org:secondaryQuantity|secondaryQuantity/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="price.amount">
		<xsl:choose>
			<xsl:when test="count(org:price.amount|price.amount/@text()) &gt; 0 ">
				<xsl:element name="SettlementAmount">
					<xsl:attribute name="v"><xsl:value-of select="org:price.amount|price.amount/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
