<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:org="urn:iec62325.351:tc57wg16:451-5:problemdocument:3:0" xmlns="urn:entsoe.eu:wgedi:epsd:problemstatementdocument:2:1" version="1.0" exclude-result-prefixes="org">
	<xsl:output method="xml"/>
	<xsl:template match="org:ProblemStatement_MarketDocument|ProblemStatement_MarketDocument">
		<ProblemStatementDocument>
			<xsl:call-template name="mRID"/>
			<xsl:call-template name="revisionNumber"/>
			<xsl:call-template name="type"/>
			<xsl:call-template name="sender_MarketParticipant.mRID"/>
			<xsl:call-template name="sender_MarketParticipant.marketRole.type"/>
			<xsl:call-template name="receiver_MarketParticipant.mRID"/>
			<xsl:call-template name="receiver_MarketParticipant.marketRole.type"/>
			<xsl:call-template name="createdDateTime"/>
			<xsl:call-template name="period.timeInterval"/>
			<xsl:call-template name="expected_MarketDocument.type"/>
			<xsl:call-template name="expected_MarketDocument.createdDateTime"/>
			<xsl:call-template name="expected_MarketDocument.process.processType"/>
			<xsl:call-template name="delivery_MarketDocument.createdDateTime"/>
			<xsl:call-template name="domain.mRID"/>
			<xsl:call-template name="Reason"/>
		</ProblemStatementDocument>
	</xsl:template>
	<xsl:template name="Reason">
		<xsl:for-each select="org:Reason|Reason">
			<xsl:element name="Reason">
				<xsl:call-template name="code"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<!-- Entities Information -->
	<!-- DocumentIdentification -->
	<xsl:template name="mRID">
		<xsl:choose>
			<xsl:when test="count(org:mRID|mRID/@text()) &gt; 0 ">
				<xsl:element name="DocumentIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:mRID|mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- -->
	<!-- Document Version -->
	<xsl:template name="revisionNumber">
		<xsl:choose>
			<xsl:when test="count(org:revisionNumber|revisionNumber/@text()) &gt; 0 ">
				<xsl:element name="DocumentVersion">
					<xsl:attribute name="v"><xsl:value-of select="org:revisionNumber|revisionNumber/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- -->
	<!-- Document Type -->
	<xsl:template name="type">
		<xsl:choose>
			<xsl:when test="count(org:type|type/@text()) &gt; 0 ">
				<xsl:element name="DocumentType">
					<xsl:attribute name="v"><xsl:value-of select="org:type|type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- SenderIdentification -->
	<xsl:template name="sender_MarketParticipant.mRID">
		<xsl:element name="SenderIdentification">
			<xsl:attribute name="v"><xsl:value-of select="org:sender_MarketParticipant.mRID|sender_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:sender_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
		</xsl:element>
	</xsl:template>
	<!-- SenderRole -->
	<xsl:template name="sender_MarketParticipant.marketRole.type">
		<xsl:choose>
			<xsl:when test="count(org:sender_MarketParticipant.marketRole.type|sender_MarketParticipant.marketRole.type/@text()) &gt; 0 ">
				<xsl:element name="SenderRole">
					<xsl:attribute name="v"><xsl:value-of select="org:sender_MarketParticipant.marketRole.type|sender_MarketParticipant.marketRole.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- ReceiverIdentification -->
	<xsl:template name="receiver_MarketParticipant.mRID">
		<xsl:element name="ReceiverIdentification">
			<xsl:attribute name="v"><xsl:value-of select="org:receiver_MarketParticipant.mRID|receiver_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:receiver_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
		</xsl:element>
	</xsl:template>
	<!-- ReceiverRole -->
	<xsl:template name="receiver_MarketParticipant.marketRole.type">
		<xsl:choose>
			<xsl:when test="count(org:receiver_MarketParticipant.marketRole.type|receiver_MarketParticipant.marketRole.type/@text()) &gt; 0 ">
				<xsl:element name="ReceiverRole">
					<xsl:attribute name="v"><xsl:value-of select="org:receiver_MarketParticipant.marketRole.type|receiver_MarketParticipant.marketRole.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- CreationDateTime -->
	<xsl:template name="createdDateTime">
		<xsl:choose>
			<xsl:when test="count(org:createdDateTime|createdDateTime/@text()) &gt; 0 ">
				<xsl:element name="CreationDateTime">
					<xsl:attribute name="v"><xsl:value-of select="org:createdDateTime|createdDateTime/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- Time internval -->
	<xsl:template name="period.timeInterval">
		<xsl:choose>
			<xsl:when test="count(org:period.timeInterval|period.timeInterval/@text()) &gt; 0 ">
				<xsl:element name="RelatedTimeInterval">
					<xsl:attribute name="v"><xsl:value-of select="concat(substring(translate(translate(org:period.timeInterval|period.timeInterval/@text(),'&#x9;', ''),'&#xA;',''),1,17),'/',substring(translate(translate(org:period.timeInterval|period.timeInterval/@text(),'&#x9;',''),'&#xA;',''),18,17))"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- -->
	<!-- Expected Type -->
	<xsl:template name="expected_MarketDocument.type">
		<xsl:choose>
			<xsl:when test="count(org:expected_MarketDocument.type|expected_MarketDocument.type/@text()) &gt; 0 ">
				<xsl:element name="ExpectedDocumentType">
					<xsl:attribute name="v"><xsl:value-of select="org:expected_MarketDocument.type|expected_MarketDocument.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- Created Date Time -->
	<xsl:template name="expected_MarketDocument.createdDateTime">
		<xsl:choose>
			<xsl:when test="count(org:expected_MarketDocument.createdDateTime|expected_MarketDocument.createdDateTime/@text()) &gt; 0 ">
				<xsl:element name="ExpectedDocumentDeadline">
					<xsl:attribute name="v"><xsl:value-of select="org:expected_MarketDocument.createdDateTime|expected_MarketDocument.createdDateTime/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- Process Type -->
	<xsl:template name="expected_MarketDocument.process.processType">
		<xsl:choose>
			<xsl:when test="count(org:expected_MarketDocument.process.processType|expected_MarketDocument.process.processType/@text()) &gt; 0 ">
				<xsl:element name="ExpectedProcessType">
					<xsl:attribute name="v"><xsl:value-of select="org:expected_MarketDocument.process.processType|expected_MarketDocument.process.processType/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- Delivery  Date Time -->
	<xsl:template name="delivery_MarketDocument.createdDateTime">
		<xsl:choose>
			<xsl:when test="count(org:delivery_MarketDocument.createdDateTime|delivery_MarketDocument.createdDateTime/@text()) &gt; 0 ">
				<xsl:element name="ExpectedDeliveryDateTime">
					<xsl:attribute name="v"><xsl:value-of select="org:delivery_MarketDocument.createdDateTime|delivery_MarketDocument.createdDateTime/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- Domain -->
	<!-- ReceiverIdentification -->
	<xsl:template name="domain.mRID">
		<xsl:choose>
			<xsl:when test="count(org:domain.mRID|domain.mRID/@text()) &gt; 0 ">
				<xsl:element name="Domain">
					<xsl:attribute name="v"><xsl:value-of select="org:domain.mRID|domain.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:domain.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- Reason code -->
	<xsl:template name="code">
		<xsl:element name="ReasonCode">
			<xsl:attribute name="v"><xsl:value-of select="org:code|code/@text()"/></xsl:attribute>
		</xsl:element>
		<xsl:choose>
			<xsl:when test="count(org:text|text/@text()) &gt; 0 ">
				<xsl:element name="ReasonText">
					<xsl:attribute name="v"><xsl:value-of select="org:text|text/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
