<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:org="urn:iec62325.351:tc57wg16:451-5:statusrequestdocument:4:0" xmlns="urn:entsoe.eu:wgedi:esr:statusrequestdocument:3:0" version="1.0" exclude-result-prefixes="org">
	<xsl:output method="xml"/>
	<xsl:template match="org:StatusRequest_MarketDocument|StatusRequest_MarketDocument">
		<StatusRequestDocument>
			<xsl:call-template name="mRID"/>
			<xsl:call-template name="type"/>
			<xsl:call-template name="sender_MarketParticipant.mRID"/>
			<xsl:call-template name="sender_MarketParticipant.marketRole.type"/>
			<xsl:call-template name="receiver_MarketParticipant.mRID"/>
			<xsl:call-template name="receiver_MarketParticipant.marketRole.type"/>
			<xsl:call-template name="createdDateTime"/>
			<xsl:call-template name="AttributeInstanceComponent"/>
		</StatusRequestDocument>
	</xsl:template>
	<xsl:template name="AttributeInstanceComponent">
		<xsl:for-each select="org:AttributeInstanceComponent|AttributeInstanceComponent">
			<xsl:element name="RequestComponent">
				<xsl:call-template name="attribute"/>
				<xsl:call-template name="attributeValue"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<!-- Entities Information -->
	<!-- DocumentIdentification -->
	<xsl:template name="mRID">
		<xsl:choose>
			<xsl:when test="count(org:mRID|mRID/@text()) &gt; 0 ">
				<xsl:element name="DocumentIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:mRID|mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- -->
	<xsl:template name="type">
		<xsl:choose>
			<xsl:when test="count(org:type|type/@text()) &gt; 0 ">
				<xsl:element name="DocumentType">
					<xsl:attribute name="v"><xsl:value-of select="org:type|type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- SenderIdentification -->
	<xsl:template name="sender_MarketParticipant.mRID">
		<xsl:element name="SenderIdentification">
			<xsl:attribute name="v">
				<xsl:value-of select="org:sender_MarketParticipant.mRID|sender_MarketParticipant.mRID/@text()"/>
			</xsl:attribute>
			<xsl:attribute name="codingScheme">
				<xsl:value-of select="org:sender_MarketParticipant.mRID/@codingScheme"/>
			</xsl:attribute>
		</xsl:element>
	</xsl:template>
	<!-- SenderRole -->
	<xsl:template name="sender_MarketParticipant.marketRole.type">
		<xsl:choose>
			<xsl:when test="count(org:sender_MarketParticipant.marketRole.type|sender_MarketParticipant.marketRole.type/@text()) &gt; 0 ">
				<xsl:element name="SenderRole">
					<xsl:attribute name="v">
						<xsl:value-of select="org:sender_MarketParticipant.marketRole.type|sender_MarketParticipant.marketRole.type/@text()"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- ReceiverIdentification -->
	<xsl:template name="receiver_MarketParticipant.mRID">
		<xsl:element name="ReceiverIdentification">
			<xsl:attribute name="v">
				<xsl:value-of select="org:receiver_MarketParticipant.mRID|receiver_MarketParticipant.mRID/@text()"/>
			</xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:receiver_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
		</xsl:element>
	</xsl:template>
	<!-- ReceiverRole -->
	<xsl:template name="receiver_MarketParticipant.marketRole.type">
		<xsl:choose>
			<xsl:when test="count(org:receiver_MarketParticipant.marketRole.type|receiver_MarketParticipant.marketRole.type/@text()) &gt; 0 ">
				<xsl:element name="ReceiverRole">
					<xsl:attribute name="v">
						<xsl:value-of select="org:receiver_MarketParticipant.marketRole.type|receiver_MarketParticipant.marketRole.type/@text()"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- CreationDateTime -->
	<xsl:template name="createdDateTime">
		<xsl:choose>
			<xsl:when test="count(org:createdDateTime|createdDateTime/@text()) &gt; 0 ">
				<xsl:element name="CreationDateTime">
					<xsl:attribute name="v"><xsl:value-of select="org:createdDateTime|createdDateTime/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- RequestedAttribute -->
	<xsl:template name="attribute">
		<xsl:choose>
			<xsl:when test="count(org:attribute|attribute/@text()) &gt; 0 ">
				<xsl:element name="RequestedAttribute">
					<xsl:attribute name="v"><xsl:value-of select="org:attribute|attribute/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- RequestedAttributeValue -->
	<xsl:template name="attributeValue">
		<xsl:element name="RequestedAttributeValue">
			<xsl:attribute name="v"><xsl:value-of select="org:attributeValue|attributeValue/@text()"/></xsl:attribute>
			<xsl:choose>
				<xsl:when test="count(org:attributeValue/@codingScheme) &gt; 0 ">
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:attributeValue/@codingScheme"/></xsl:attribute>
				</xsl:when>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
</xsl:stylesheet>
