<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:org="urn:iec62325.351:tc57wg16:451-7:activationdocument:6:0" xmlns="urn:entsoe.eu:wgedi:errp:activatondocument:5:0" version="1.0" exclude-result-prefixes="org">
	<xsl:output method="xml"/>
	<xsl:template match="org:Activation_MarketDocument|Activation_MarketDocument">
		<ActivationDocument>
			<xsl:call-template name="mRID"/>
			<xsl:call-template name="revisionNumber"/>
			<xsl:call-template name="type"/>
			<xsl:call-template name="process.processType"/>
			<xsl:call-template name="sender_MarketParticipant.mRID"/>
			<xsl:call-template name="sender_MarketParticipant.marketRole.type"/>
			<xsl:call-template name="receiver_MarketParticipant.mRID"/>
			<xsl:call-template name="receiver_MarketParticipant.marketRole.type"/>
			<xsl:call-template name="createdDateTime"/>
			<xsl:call-template name="activation_Time_Period.timeInterval"/>
			<xsl:call-template name="domain.mRID"/>
			<xsl:call-template name="subject_MarketParticipant.mRID"/>
			<xsl:call-template name="subject_MarketParticipant.marketRole.type"/>
			<xsl:call-template name="order_MarketDocument.mRID"/>		
			<xsl:call-template name="order_MarketDocument.revisionNumber"/>		
			<xsl:call-template name="TimeSeries"/>
		</ActivationDocument>
	</xsl:template>
	<!-- Entities Information -->
	<xsl:template name="mRID">
		<xsl:choose>
			<xsl:when test="count(org:mRID|mRID/@text()) &gt; 0 ">
				<xsl:element name="DocumentIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:mRID|mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="revisionNumber">
		<xsl:choose>
			<xsl:when test="count(org:revisionNumber|revisionNumber/@text()) &gt; 0 ">
				<xsl:element name="DocumentVersion">
					<xsl:attribute name="v"><xsl:value-of select="org:revisionNumber|revisionNumber/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="type">
		<xsl:choose>
			<xsl:when test="count(org:type|type/@text()) &gt; 0 ">
				<xsl:element name="DocumentType">
					<xsl:attribute name="v"><xsl:value-of select="org:type|type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="process.processType">
		<xsl:choose>
			<xsl:when test="count(org:process.processType|process.processType/@text()) &gt; 0 ">
				<xsl:element name="ProcessType">
					<xsl:attribute name="v"><xsl:value-of select="org:process.processType|process.processType/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="sender_MarketParticipant.mRID">
		<xsl:element name="SenderIdentification">
			<xsl:attribute name="v"><xsl:value-of select="org:sender_MarketParticipant.mRID|sender_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:sender_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
		</xsl:element>
	</xsl:template>
	<xsl:template name="sender_MarketParticipant.marketRole.type">
		<xsl:choose>
			<xsl:when test="count(org:sender_MarketParticipant.marketRole.type|sender_MarketParticipant.marketRole.type/@text()) &gt; 0 ">
				<xsl:element name="SenderRole">
					<xsl:attribute name="v"><xsl:value-of select="org:sender_MarketParticipant.marketRole.type|sender_MarketParticipant.marketRole.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="receiver_MarketParticipant.mRID">
		<xsl:element name="ReceiverIdentification">
			<xsl:attribute name="v"><xsl:value-of select="org:receiver_MarketParticipant.mRID|receiver_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:receiver_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
		</xsl:element>
	</xsl:template>
	<xsl:template name="receiver_MarketParticipant.marketRole.type">
		<xsl:choose>
			<xsl:when test="count(org:receiver_MarketParticipant.marketRole.type|receiver_MarketParticipant.marketRole.type/@text()) &gt; 0 ">
				<xsl:element name="ReceiverRole">
					<xsl:attribute name="v">
					<xsl:value-of select="org:receiver_MarketParticipant.marketRole.type|receiver_MarketParticipant.marketRole.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="createdDateTime">
		<xsl:choose>
			<xsl:when test="count(org:createdDateTime|createdDateTime/@text()) &gt; 0 ">
				<xsl:element name="CreationDateTime">
					<xsl:attribute name="v"><xsl:value-of select="org:createdDateTime|createdDateTime/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="activation_Time_Period.timeInterval">
		<xsl:choose>
			<xsl:when test="count(org:activation_Time_Period.timeInterval|activation_Time_Period.timeInterval/@text()) &gt; 0 ">
				<xsl:element name="ActivationTimeInterval">
					<xsl:attribute name="v">
					<xsl:value-of select="concat(substring(translate(translate(org:activation_Time_Period.timeInterval|activation_Time_Period.timeInterval/@text(),'&#x9;', ''),'&#xA;',''),1,17),'/',substring(translate(translate(org:activation_Time_Period.timeInterval|activation_Time_Period.timeInterval/@text(),'&#x9;',''),'&#xA;',''),18,17))"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="domain.mRID">
		<xsl:choose>
			<xsl:when test="count(org:domain.mRID|domain.mRID/@text()) &gt; 0 ">
				<xsl:element name="Domain">
					<xsl:attribute name="v"><xsl:value-of select="org:domain.mRID|domain.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:domain.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="subject_MarketParticipant.mRID">
	<xsl:choose>
	<xsl:when test="count(org:subject_MarketParticipant.mRID|subject_MarketParticipant.mRID/@text()) &gt; 0 ">
		<xsl:element name="SubjectParty">
			<xsl:attribute name="v"><xsl:value-of select="org:subject_MarketParticipant.mRID|subject_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:subject_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
		</xsl:element>
		</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="subject_MarketParticipant.marketRole.type">
		<xsl:choose>
			<xsl:when test="count(org:subject_MarketParticipant.marketRole.type|subject_MarketParticipant.marketRole.type/@text()) &gt; 0 ">
				<xsl:element name="SubjectRole">
					<xsl:attribute name="v">
					<xsl:value-of select="org:subject_MarketParticipant.marketRole.type|subject_MarketParticipant.marketRole.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="order_MarketDocument.mRID">
		<xsl:choose>
			<xsl:when test="count(org:order_MarketDocument.mRID|order_MarketDocument.mRID/@text()) &gt; 0 ">
				<xsl:element name="OrderIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:order_MarketDocument.mRID|order_MarketDocument.mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="order_MarketDocument.revisionNumber">
		<xsl:choose>
			<xsl:when test="count(org:order_MarketDocument.revisionNumber|order_MarketDocument.revisionNumber/@text()) &gt; 0 ">
				<xsl:element name="OrderIdentificationVersion">
					<xsl:attribute name="v"><xsl:value-of select="org:order_MarketDocument.revisionNumber|order_MarketDocument.revisionNumber/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- TimeSeries -->
	<xsl:template name="TimeSeries">
		<xsl:for-each select="org:TimeSeries|TimeSeries">
			<xsl:element name="ActivationTimeSeries">
			<xsl:call-template name="TimeSeriesmRID"/>
			<xsl:call-template name="resourceProvider_MarketParticipant.mRID"/>
			<xsl:call-template name="businessType"/>
			<xsl:call-template name="acquiring_Domain.mRID"/>
			<xsl:call-template name="connecting_Domain.mRID"/>
			<xsl:call-template name="measurement_Unit.name"/>
			<xsl:call-template name="flowDirection.direction"/>
			<xsl:call-template name="marketObjectStatus.status"/>
			<xsl:call-template name="registeredResource.mRID"/>
			<xsl:call-template name="Period"/>
			<xsl:call-template name="Reason"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<!-- Elements -->
	<xsl:template name="TimeSeriesmRID">
		<xsl:choose>
			<xsl:when test="count(org:mRID|mRID/@text()) &gt; 0 ">
				<xsl:element name="AllocationtIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:mRID|mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="resourceProvider_MarketParticipant.mRID">
	<xsl:choose>
	<xsl:when test="count(org:resourceProvider_MarketParticipant.mRID|resourceProvider_MarketParticipant.mRID/@text()) &gt; 0 ">
		<xsl:element name="ResourceProvider">
			<xsl:attribute name="v"><xsl:value-of select="org:resourceProvider_MarketParticipant.mRID|resourceProvider_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:resourceProvider_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
		</xsl:element>
		</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="businessType">
		<xsl:choose>
			<xsl:when test="count(org:businessType|businessType/@text()) &gt; 0 ">
				<xsl:element name="BusinessType">
					<xsl:attribute name="v"><xsl:value-of select="org:businessType|businessType/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="acquiring_Domain.mRID">
		<xsl:choose>
			<xsl:when test="count(org:acquiring_Domain.mRID|acquiring_Domain.mRID/@text()) &gt; 0 ">
				<xsl:element name="AcquiringArea">
					<xsl:attribute name="v"><xsl:value-of select="org:acquiring_Domain.mRID|acquiring_Domain.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:acquiring_Domain.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="connecting_Domain.mRID">
		<xsl:choose>
			<xsl:when test="count(org:connecting_Domain.mRID|connecting_Domain.mRID/@text()) &gt; 0 ">
				<xsl:element name="ConnectingArea">
					<xsl:attribute name="v"><xsl:value-of select="org:connecting_Domain.mRID|connecting_Domain.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:connecting_Domain.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="measurement_Unit.name">
		<xsl:choose>
			<xsl:when test="count(org:measurement_Unit.name|measurement_Unit.name/@text()) &gt; 0 ">
				<xsl:element name="MeasureUnit">
					<xsl:attribute name="v"><xsl:value-of select="org:measurement_Unit.name|measurement_Unit.name/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="flowDirection.direction">
		<xsl:choose>
			<xsl:when test="count(org:flowDirection.direction|flowDirection.direction/@text()) &gt; 0 ">
				<xsl:element name="Direction">
					<xsl:attribute name="v"><xsl:value-of select="org:flowDirection.direction|flowDirection.direction/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="marketObjectStatus.status">
		<xsl:choose>
			<xsl:when test="count(org:marketObjectStatus.status|marketObjectStatus.status/@text()) &gt; 0 ">
				<xsl:element name="Status">
					<xsl:attribute name="v"><xsl:value-of select="org:marketObjectStatus.status|marketObjectStatus.status/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="registeredResource.mRID">
	<xsl:choose>
			<xsl:when test="count(org:registeredResource.mRID|registeredResource.mRID/@text()) &gt; 0 ">
			<xsl:element name="ResourceObject">
			<xsl:attribute name="v"><xsl:value-of select="org:registeredResource.mRID|registeredResource.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:registeredResource.mRID/@codingScheme"/></xsl:attribute>
			</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="Period">
		<xsl:for-each select="org:Period|Period">
			<xsl:element name="Period">
			<xsl:call-template name="timeInterval"/>
			<xsl:call-template name="resolution"/>
			<xsl:call-template name="Periodpoint"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="Periodpoint">
		<xsl:for-each select="org:Point|Point">
			<xsl:element name="Interval">
			<xsl:call-template name="position"/>
			<xsl:call-template name="quantity"/>
			<xsl:call-template name="Reason"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<!-- Elements -->	
	<xsl:template name="timeInterval">
		<xsl:choose>
			<xsl:when test="count(org:timeInterval|timeInterval/@text()) &gt; 0 ">
				<xsl:element name="TimeInterval">
					<xsl:attribute name="v">
					<xsl:value-of select="concat(substring(translate(translate(org:timeInterval|timeInterval/@text(),'&#x9;', ''),'&#xA;',''),1,17),'/',substring(translate(translate(org:timeInterval|timeInterval/@text(),'&#x9;',''),'&#xA;',''),18,17))"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="resolution">
		<xsl:choose>
			<xsl:when test="count(org:resolution|resolution/@text()) &gt; 0 ">
				<xsl:element name="Resolution">
					<xsl:attribute name="v"><xsl:value-of select="org:resolution|resolution/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="position">
		<xsl:choose>
			<xsl:when test="count(org:position|position/@text()) &gt; 0 ">
				<xsl:element name="Pos">
					<xsl:attribute name="v"><xsl:value-of select="org:position|position/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="quantity">
		<xsl:choose>
			<xsl:when test="count(org:quantity|quantity/@text()) &gt; 0 ">
				<xsl:element name="Qty">
					<xsl:attribute name="v"><xsl:value-of select="org:quantity|quantity/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="Reason">
		<xsl:for-each select="org:Reason|Reason">
			<xsl:element name="Reason">
				<xsl:call-template name="code"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="code">
		<xsl:element name="ReasonCode">
			<xsl:attribute name="v"><xsl:value-of select="org:code|code/@text()"/></xsl:attribute>
		</xsl:element>
		<xsl:choose>
			<xsl:when test="count(org:text|text/@text()) &gt; 0 ">
				<xsl:element name="ReasonText">
					<xsl:attribute name="v"><xsl:value-of select="org:text|text/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
