<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:org="urn:iec62325.351:tc57wg16:451-7:reservationallocationresultdocument:6:0" xmlns="urn:entsoe.eu:wgedi:errp:reserveallocationresultdocument:5:0" version="1.0" exclude-result-prefixes="org">
	<xsl:output method="xml"/>
	<xsl:template match="org:ReserveAllocation_MarketDocument|ReserveAllocation_MarketDocument">
		<ReserveAllocationResultDocument>
			<xsl:call-template name="mRID"/>
			<xsl:call-template name="revisionNumber"/>
			<xsl:call-template name="type"/>
			<xsl:call-template name="process.processType"/>
			<xsl:call-template name="sender_MarketParticipant.mRID"/>
			<xsl:call-template name="sender_MarketParticipant.marketRole.type"/>
			<xsl:call-template name="receiver_MarketParticipant.mRID"/>
			<xsl:call-template name="receiver_MarketParticipant.marketRole.type"/>
			<xsl:call-template name="createdDateTime"/>
			<xsl:call-template name="reserveBid_Period.timeInterval"/>
			<xsl:call-template name="domain.mRID"/>
			<xsl:call-template name="TimeSeries"/>
			<xsl:call-template name="Reason"/>
		</ReserveAllocationResultDocument>
	</xsl:template>
	<xsl:template name="TimeSeries">
		<xsl:for-each select="org:TimeSeries|TimeSeries">
			<xsl:element name="AllocationTimeSeries">
				<xsl:call-template name="TimeSeriesmRID"/>
				<xsl:call-template name="bid_Original_MarketDocument.mRID"/>
				<xsl:call-template name="bid_Original_MarketDocument.revisionNumber"/>
				<xsl:call-template name="bid_Original_MarketDocument.bid_TimeSeries.mRID"/>
				<xsl:call-template name="bid_Original_MarketDocument.tendering_MarketParticipant.mRID"/>
				<xsl:call-template name="auction.mRID"/>
				<xsl:call-template name="businessType"/>
				<xsl:call-template name="acquiring_Domain.mRID"/>
				<xsl:call-template name="connecting_Domain.mRID"/>
				<xsl:call-template name="marketAgreement.type"/>
				<xsl:call-template name="marketAgreement.mRID"/>
				<xsl:call-template name="quantity_Measure_Unit.name"/>
				<xsl:call-template name="currency_Unit.name"/>
				<xsl:call-template name="price_Measure_Unit.name"/>
				<xsl:call-template name="energy_Measurement_Unit.name"/>
				<xsl:call-template name="registeredResource.mRID"/>
				<xsl:call-template name="flowDirection.direction"/>
				<xsl:call-template name="minimumActivation_Quantity.quantity"/>
				<xsl:call-template name="stepIncrement_Quantity.quantity"/>
				<xsl:call-template name="marketAgreement.createdDateTime"/>
				<xsl:call-template name="orderNumber_AttributeInstanceComponent.position"/>
				<xsl:call-template name="activation_ConstraintDuration.duration"/>
				<xsl:call-template name="resting_ConstraintDuration.duration"/>
				<xsl:call-template name="minimum_ConstraintDuration.duration"/>
				<xsl:call-template name="maximum_ConstraintDuration.duration"/>
				<xsl:call-template name="Series_Period"/>
				<xsl:call-template name="Reason"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="Series_Period">
		<xsl:for-each select="org:Period|Period">
			<xsl:element name="Period">
				<xsl:call-template name="timeInterval"/>
				<xsl:call-template name="resolution"/>
				<xsl:call-template name="Periodpoint"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="Periodpoint">
		<xsl:for-each select="org:Point|Point">
			<xsl:element name="Interval">
				<xsl:call-template name="position"/>
				<xsl:call-template name="quantity"/>
				<xsl:call-template name="price.amount"/>
				<xsl:call-template name="secondaryQuantity"/>
				<xsl:call-template name="bid_Price.amount"/>
				<xsl:call-template name="bidEnergy_Price.amount"/>
				<xsl:call-template name="energy_Price.amount"/>
				<xsl:call-template name="Reason"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<!--Period classes-->
	<xsl:template name="mRID">
		<xsl:choose>
			<xsl:when test="count(org:mRID|mRID/@text()) &gt; 0 ">
				<xsl:element name="DocumentIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:mRID|mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="revisionNumber">
		<xsl:choose>
			<xsl:when test="count(org:revisionNumber|revisionNumber/@text()) &gt; 0 ">
				<xsl:element name="DocumentVersion">
					<xsl:attribute name="v"><xsl:value-of select="org:revisionNumber|revisionNumber/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="type">
		<xsl:choose>
			<xsl:when test="count(org:type|type/@text()) &gt; 0 ">
				<xsl:element name="DocumentType">
					<xsl:attribute name="v"><xsl:value-of select="org:type|type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="process.processType">
		<xsl:choose>
			<xsl:when test="count(org:process.processType|process.processType/@text()) &gt; 0 ">
				<xsl:element name="ProcessType">
					<xsl:attribute name="v"><xsl:value-of select="org:process.processType|process.processType/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="sender_MarketParticipant.mRID">
		<xsl:element name="SenderIdentification">
			<xsl:attribute name="v"><xsl:value-of select="org:sender_MarketParticipant.mRID|sender_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:sender_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
		</xsl:element>
	</xsl:template>
	<xsl:template name="sender_MarketParticipant.marketRole.type">
		<xsl:choose>
			<xsl:when test="count(org:sender_MarketParticipant.marketRole.type|sender_MarketParticipant.marketRole.type/@text()) &gt; 0 ">
				<xsl:element name="SenderRole">
					<xsl:attribute name="v"><xsl:value-of select="org:sender_MarketParticipant.marketRole.type|sender_MarketParticipant.marketRole.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="receiver_MarketParticipant.mRID">
		<xsl:element name="ReceiverIdentification">
			<xsl:attribute name="v"><xsl:value-of select="org:receiver_MarketParticipant.mRID|receiver_MarketParticipant.mRID/@text()"/></xsl:attribute>
			<xsl:attribute name="codingScheme"><xsl:value-of select="org:receiver_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
		</xsl:element>
	</xsl:template>
	<xsl:template name="receiver_MarketParticipant.marketRole.type">
		<xsl:choose>
			<xsl:when test="count(org:receiver_MarketParticipant.marketRole.type|receiver_MarketParticipant.marketRole.type/@text()) &gt; 0 ">
				<xsl:element name="ReceiverRole">
					<xsl:attribute name="v"><xsl:value-of select="org:receiver_MarketParticipant.marketRole.type|receiver_MarketParticipant.marketRole.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="createdDateTime">
		<xsl:choose>
			<xsl:when test="count(org:createdDateTime|createdDateTime/@text()) &gt; 0 ">
				<xsl:element name="CreationDateTime">
					<xsl:attribute name="v"><xsl:value-of select="org:createdDateTime|createdDateTime/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="reserveBid_Period.timeInterval">
		<xsl:choose>
			<xsl:when test="count(org:reserveBid_Period.timeInterval|reserveBid_Period.timeInterval/@text()) &gt; 0 ">
				<xsl:element name="ReserveBidTimeInterval">
					<xsl:attribute name="v"><xsl:value-of select="concat(substring(translate(translate(org:reserveBid_Period.timeInterval|reserveBid_Period.timeInterval/@text(),'&#x9;', ''),'&#xA;',''),1,17),'/',substring(translate(translate(org:reserveBid_Period.timeInterval|reserveBid_Period.timeInterval/@text(),'&#x9;',''),'&#xA;',''),18,17))"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="domain.mRID">
		<xsl:choose>
			<xsl:when test="count(org:domain.mRID|domain.mRID/@text()) &gt; 0 ">
				<xsl:element name="Domain">
					<xsl:attribute name="v"><xsl:value-of select="org:domain.mRID|domain.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:domain.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- TimeSeries -->
	<!-- Elements -->
	<xsl:template name="TimeSeriesmRID">
		<xsl:choose>
			<xsl:when test="count(org:mRID|mRID/@text()) &gt; 0 ">
				<xsl:element name="TimeSeriesIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:mRID|mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="bid_Original_MarketDocument.mRID">
		<xsl:choose>
			<xsl:when test="count(org:bid_Original_MarketDocument.mRID|bid_Original_MarketDocument.mRID/@text()) &gt; 0 ">
				<xsl:element name="ReserveBidDocumentIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:bid_Original_MarketDocument.mRID|bid_Original_MarketDocument.mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="bid_Original_MarketDocument.revisionNumber">
		<xsl:choose>
			<xsl:when test="count(org:bid_Original_MarketDocument.revisionNumber|bid_Original_MarketDocument.revisionNumber/@text()) &gt; 0 ">
				<xsl:element name="ReserveBidDocumentVersion">
					<xsl:attribute name="v"><xsl:value-of select="org:bid_Original_MarketDocument.revisionNumber|bid_Original_MarketDocument.revisionNumber/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="bid_Original_MarketDocument.bid_TimeSeries.mRID">
		<xsl:choose>
			<xsl:when test="count(org:bid_Original_MarketDocument.bid_TimeSeries.mRID|bid_Original_MarketDocument.bid_TimeSeries.mRID/@text()) &gt; 0 ">
				<xsl:element name="ReserveBidIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:bid_Original_MarketDocument.bid_TimeSeries.mRID|bid_Original_MarketDocument.bid_TimeSeries.mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="bid_Original_MarketDocument.tendering_MarketParticipant.mRID">
		<xsl:choose>
			<xsl:when test="count(org:bid_Original_MarketDocument.tendering_MarketParticipant.mRID|bid_Original_MarketDocument.tendering_MarketParticipant.mRID/@text()) &gt; 0 ">
				<xsl:element name="TenderingParty">
					<xsl:attribute name="v"><xsl:value-of select="org:bid_Original_MarketDocument.tendering_MarketParticipant.mRID|bid_Original_MarketDocument.tendering_MarketParticipant.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:bid_Original_MarketDocument.tendering_MarketParticipant.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="auction.mRID">
		<xsl:choose>
			<xsl:when test="count(org:auction.mRID|auction.mRID/@text()) &gt; 0 ">
				<xsl:element name="AuctionIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:auction.mRID|auction.mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="businessType">
		<xsl:choose>
			<xsl:when test="count(org:businessType|businessType/@text()) &gt; 0 ">
				<xsl:element name="BusinessType">
					<xsl:attribute name="v"><xsl:value-of select="org:businessType|businessType/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="acquiring_Domain.mRID">
		<xsl:choose>
			<xsl:when test="count(org:acquiring_Domain.mRID|acquiring_Domain.mRID/@text()) &gt; 0 ">
				<xsl:element name="AcquiringArea">
					<xsl:attribute name="v"><xsl:value-of select="org:acquiring_Domain.mRID|acquiring_Domain.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:acquiring_Domain.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="connecting_Domain.mRID">
		<xsl:choose>
			<xsl:when test="count(org:connecting_Domain.mRID|connecting_Domain.mRID/@text()) &gt; 0 ">
				<xsl:element name="ConnectingArea">
					<xsl:attribute name="v"><xsl:value-of select="org:connecting_Domain.mRID|connecting_Domain.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:connecting_Domain.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="marketAgreement.type">
		<xsl:choose>
			<xsl:when test="count(org:marketAgreement.type|marketAgreement.type/@text()) &gt; 0 ">
				<xsl:element name="ContractType">
					<xsl:attribute name="v"><xsl:value-of select="org:marketAgreement.type|marketAgreement.type/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="marketAgreement.mRID">
		<xsl:choose>
			<xsl:when test="count(org:marketAgreement.mRID|marketAgreement.mRID/@text()) &gt; 0 ">
				<xsl:element name="ContractIdentification">
					<xsl:attribute name="v"><xsl:value-of select="org:marketAgreement.mRID|marketAgreement.mRID/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="quantity_Measure_Unit.name">
		<xsl:choose>
			<xsl:when test="count(org:quantity_Measure_Unit.name|quantity_Measure_Unit.name/@text()) &gt; 0 ">
				<xsl:element name="MeasureUnitQuantity">
					<xsl:attribute name="v"><xsl:value-of select="org:quantity_Measure_Unit.name|quantity_Measure_Unit.name/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="currency_Unit.name">
		<xsl:choose>
			<xsl:when test="count(org:currency_Unit.name|currency_Unit.name/@text()) &gt; 0 ">
				<xsl:element name="Currency">
					<xsl:attribute name="v"><xsl:value-of select="org:currency_Unit.name|currency_Unit.name/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="price_Measure_Unit.name">
		<xsl:choose>
			<xsl:when test="count(org:price_Measure_Unit.name|price_Measure_Unit.name/@text()) &gt; 0 ">
				<xsl:element name="MeasureUnitPrice">
					<xsl:attribute name="v"><xsl:value-of select="org:price_Measure_Unit.name|price_Measure_Unit.name/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="energy_Measurement_Unit.name">
		<xsl:choose>
			<xsl:when test="count(org:energy_Measurement_Unit.name|energy_Measurement_Unit.name/@text()) &gt; 0 ">
				<xsl:element name="MeasureUnitEnergyPrice">
					<xsl:attribute name="v"><xsl:value-of select="org:energy_Measurement_Unit.name|energy_Measurement_Unit.name/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="registeredResource.mRID">
		<xsl:choose>
			<xsl:when test="count(org:registeredResource.mRID|registeredResource.mRID/@text()) &gt; 0 ">
				<xsl:element name="ReserveObject">
					<xsl:attribute name="v"><xsl:value-of select="org:registeredResource.mRID|registeredResource.mRID/@text()"/></xsl:attribute>
					<xsl:attribute name="codingScheme"><xsl:value-of select="org:registeredResource.mRID/@codingScheme"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="flowDirection.direction">
		<xsl:choose>
			<xsl:when test="count(org:flowDirection.direction|flowDirection.direction/@text()) &gt; 0 ">
				<xsl:element name="Direction">
					<xsl:attribute name="v"><xsl:value-of select="org:flowDirection.direction|flowDirection.direction/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="minimumActivation_Quantity.quantity">
		<xsl:choose>
			<xsl:when test="count(org:minimumActivation_Quantity.quantity|minimumActivation_Quantity.quantity/@text()) &gt; 0 ">
				<xsl:element name="MinimumActivationQuantity">
					<xsl:attribute name="v"><xsl:value-of select="org:minimumActivation_Quantity.quantity|minimumActivation_Quantity.quantity/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="stepIncrement_Quantity.quantity">
		<xsl:choose>
			<xsl:when test="count(org:stepIncrement_Quantity.quantity|stepIncrement_Quantity.quantity/@text()) &gt; 0 ">
				<xsl:element name="StepIncrementQuantity">
					<xsl:attribute name="v"><xsl:value-of select="org:stepIncrement_Quantity.quantity|stepIncrement_Quantity.quantity/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="marketAgreement.createdDateTime">
		<xsl:choose>
			<xsl:when test="count(org:marketAgreement.createdDateTime|marketAgreement.createdDateTime/@text()) &gt; 0 ">
				<xsl:element name="TimeStamp">
					<xsl:attribute name="v"><xsl:value-of select="org:marketAgreement.createdDateTime|marketAgreement.createdDateTime/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="orderNumber_AttributeInstanceComponent.position">
		<xsl:choose>
			<xsl:when test="count(org:orderNumber_AttributeInstanceComponent.position|orderNumber_AttributeInstanceComponent.position/@text()) &gt; 0 ">
				<xsl:element name="OrderNumber">
					<xsl:attribute name="v"><xsl:value-of select="org:orderNumber_AttributeInstanceComponent.position|orderNumber_AttributeInstanceComponent.position/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="activation_ConstraintDuration.duration">
		<xsl:choose>
			<xsl:when test="count(org:activation_ConstraintDuration.duration|activation_ConstraintDuration.duration/@text()) &gt; 0 ">
				<xsl:element name="ActivationDuration">
					<xsl:attribute name="v"><xsl:value-of select="org:activation_ConstraintDuration.duration|activation_ConstraintDuration.duration/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="resting_ConstraintDuration.duration">
		<xsl:choose>
			<xsl:when test="count(org:resting_ConstraintDuration.duration|resting_ConstraintDuration.duration/@text()) &gt; 0 ">
				<xsl:element name="RestingDuration">
					<xsl:attribute name="v"><xsl:value-of select="org:resting_ConstraintDuration.duration|resting_ConstraintDuration.duration/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="minimum_ConstraintDuration.duration">
		<xsl:choose>
			<xsl:when test="count(org:minimum_ConstraintDuration.duration|minimum_ConstraintDuration.duration/@text()) &gt; 0 ">
				<xsl:element name="MinimumDuration">
					<xsl:attribute name="v"><xsl:value-of select="org:minimum_ConstraintDuration.duration|minimum_ConstraintDuration.duration/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="maximum_ConstraintDuration.duration">
		<xsl:choose>
			<xsl:when test="count(org:maximum_ConstraintDuration.duration|maximum_ConstraintDuration.duration/@text()) &gt; 0 ">
				<xsl:element name="MaximumDuration">
					<xsl:attribute name="v"><xsl:value-of select="org:maximum_ConstraintDuration.duration|maximum_ConstraintDuration.duration/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- Elements -->
	<xsl:template name="timeInterval">
		<xsl:choose>
			<xsl:when test="count(org:timeInterval|timeInterval/@text()) &gt; 0 ">
				<xsl:element name="TimeInterval">
					<xsl:attribute name="v"><xsl:value-of select="concat(substring(translate(translate(org:timeInterval|timeInterval/@text(),'&#x9;', ''),'&#xA;',''),1,17),'/',substring(translate(translate(org:timeInterval|timeInterval/@text(),'&#x9;',''),'&#xA;',''),18,17))"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="resolution">
		<xsl:choose>
			<xsl:when test="count(org:resolution|resolution/@text()) &gt; 0 ">
				<xsl:element name="Resolution">
					<xsl:attribute name="v"><xsl:value-of select="org:resolution|resolution/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="position">
		<xsl:choose>
			<xsl:when test="count(org:position|position/@text()) &gt; 0 ">
				<xsl:element name="Pos">
					<xsl:attribute name="v"><xsl:value-of select="org:position|position/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="quantity">
		<xsl:choose>
			<xsl:when test="count(org:quantity|quantity/@text()) &gt; 0 ">
				<xsl:element name="Qty">
					<xsl:attribute name="v"><xsl:value-of select="org:quantity|quantity/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="price.amount">
		<xsl:choose>
			<xsl:when test="count(org:price.amount|price.amount/@text()) &gt; 0 ">
				<xsl:element name="Price">
					<xsl:attribute name="v"><xsl:value-of select="org:price.amount|price.amount/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="secondaryQuantity">
		<xsl:choose>
			<xsl:when test="count(org:secondaryQuantity|secondaryQuantity/@text()) &gt; 0 ">
				<xsl:element name="BidQty">
					<xsl:attribute name="v"><xsl:value-of select="org:secondaryQuantity|secondaryQuantity/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="bid_Price.amount">
		<xsl:choose>
			<xsl:when test="count(org:bid_Price.amount|bid_Price.amount/@text()) &gt; 0 ">
				<xsl:element name="BidPrice">
					<xsl:attribute name="v"><xsl:value-of select="org:bid_Price.amount|bid_Price.amount/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="bidEnergy_Price.amount">
		<xsl:choose>
			<xsl:when test="count(org:bidEnergy_Price.amount|bidEnergy_Price.amount/@text()) &gt; 0 ">
				<xsl:element name="BidEnergyPrice">
					<xsl:attribute name="v"><xsl:value-of select="org:bidEnergy_Price.amount|bidEnergy_Price.amount/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
		<xsl:template name="energy_Price.amount">
		<xsl:choose>
			<xsl:when test="count(org:energy_Price.amount|energy_Price.amount/@text()) &gt; 0 ">
				<xsl:element name="EnergyPrice">
					<xsl:attribute name="v"><xsl:value-of select="org:energy_Price.amount|energy_Price.amount/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="Reason">
		<xsl:for-each select="org:Reason|Reason">
			<xsl:element name="Reason">
				<xsl:call-template name="code"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="code">
		<xsl:element name="ReasonCode">
			<xsl:attribute name="v"><xsl:value-of select="org:code|code/@text()"/></xsl:attribute>
		</xsl:element>
		<xsl:choose>
			<xsl:when test="count(org:text|text/@text()) &gt; 0 ">
				<xsl:element name="ReasonText">
					<xsl:attribute name="v"><xsl:value-of select="org:text|text/@text()"/></xsl:attribute>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
